using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class HookConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型
		[ProtoMember(3)]
		public uint Type { get; set; } // 类型
		[ProtoMember(4)]
		public uint Zadzior { get; set; } // 长钉
		[ProtoMember(5)]
		public uint Length { get; set; } // 长度（毫米）
		[ProtoMember(6)]
		public uint Weight { get; set; } // 重量(克)  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<HookConfig> Context => ConfigTableHelper.Table<HookConfig>();

        public static HookConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static HookConfig Get(Predicate<HookConfig> match)
        {
            return Context.Get(match);
        }
        
        public static HookConfig Fist()
        {
            return Context.Fist();
        }

        public static HookConfig Last()
        {
            return Context.Last();
        }

        public static HookConfig Fist(Predicate<HookConfig> match)
        {
            return Context.Fist(match);
        }

        public static HookConfig Last(Predicate<HookConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<HookConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<HookConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<HookConfig> GetList(Predicate<HookConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<HookConfig>(arr);
        }
        #endregion
    }
}